#!/bin/bash

# Copyright (C) 2018 VMware, Inc.  All rights reserved.
# SPDX-License-Identifier: BSD-2-Clause

# Check MP CONNECTION
connected=$(netstat -an |grep 1234 |grep ESTABLISHED)
if [ -z "$connected" ]; then
    echo "Cannot connect to MP, pls. check MP connection"
    exit 1
fi
echo "MP connection is ok"


echo "Start to migrate..."
bash /tmp/migrate.sh

if [ $? -ne 0 ]; then
  echo "migrate failed, revert setup"
  bash /tmp/revert.sh
  exit 1
fi

# After migrate, Check MP CONNECTION again
connected=$(netstat -an |grep 1234 |grep ESTABLISHED)
if [ -z "$connected" ]; then
    echo "Cannot connect to MP, log debug info"
    bash /opt/vmware/nsx-bm/debug.sh
    echo "Revert migration..."
    bash /tmp/revert.sh
    exit 1
fi
echo "MP connection is ok after migration"

echo "migrate successfully"

echo "config static route:"
bash /opt/vmware/nsx-bm/route.sh

exit 0

